@echo off
setlocal enabledelayedexpansion

:: Define the output file path on the desktop
set "desktopPath=%USERPROFILE%\Desktop"
set "outputFile=%desktopPath%\PCHF.txt"

:: Clear the output file if it exists
if exist "%outputFile%" del "%outputFile%"

:: Add header for Scheduled Tasks
echo Scheduled Tasks: >> "%outputFile%"
echo. >> "%outputFile%"

:: Query scheduled tasks and remove extra spaces
for /f "tokens=2 delims=:" %%a in ('schtasks /query /fo list ^| findstr "TaskName:"') do (
    set "cleanTask=%%a"
    set "cleanTask=!cleanTask:      \=!"
    echo C:\Windows\system32\tasks\!cleanTask! >> "%outputFile%"
)

:: Add header for Services
echo. >> "%outputFile%"
echo Services: >> "%outputFile%"
echo. >> "%outputFile%"

:: Path to services in the registry
SET ServicesPath=HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services

:: Retrieve all service names
for /f "tokens=*" %%a in ('reg query "%ServicesPath%"') do (
    :: Fetch Start type for each service
    for /f "tokens=3" %%b in ('reg query "%%a" /v Start 2^>nul ^| find "REG_DWORD"') do (
        set "hex=%%b"
        set "hex=!hex:0x=!"
        set /a "dec=0x!hex!"
        echo reg add "%%a" /v "Start" /t REG_DWORD /d "!dec!" /f >> "%outputFile%"
    )
)

:: Notify the user
echo Scheduled tasks and services have been saved to 'PCHF.txt' on your desktop.

endlocal
